/*
 * Main.fx
 */

package translatetdemo;

import javafx.animation.Interpolator;

import javafx.animation.transition.TranslateTransition;

import javafx.scene.Group;
import javafx.scene.Scene;

import javafx.scene.effect.DropShadow;

import javafx.scene.input.MouseEvent;

import javafx.scene.paint.Color;
import javafx.scene.paint.LinearGradient;
import javafx.scene.paint.Stop;

import javafx.scene.shape.Rectangle;

import javafx.scene.text.Font;
import javafx.scene.text.Text;

import javafx.stage.Stage;

def BACKGROUND_PAINT = LinearGradient
{
    startX: 0.0
    startY: 0.0
    endX: 0.0
    endY: 1.0
    stops:
    [
        Stop { offset: 0.0 color: Color.BLUE },
        Stop { offset: 1.0 color: Color.LIGHTSKYBLUE }
    ]
}

Stage
{
    title: "TranslateTransition Demo"
    width: 400
    height: 200

    var scene: Scene
    scene: scene = Scene
    {
        fill: BACKGROUND_PAINT

        var r: Rectangle
        var st: ScrollableText
        content: Group
        {
            content:
            [
                r = Rectangle
                {
                    x: 0
                    y: 0
                    width: 200
                    height: 80
                    arcWidth: 10
                    arcHeight: 10

                    translateX: bind (scene.width-r.layoutBounds.width)/2
                    translateY: bind (scene.height-r.layoutBounds.height)/2

                    fill: Color.LIGHTYELLOW
                    stroke: Color.BLACK
                    strokeWidth: 5

                    onMouseClicked: function (me: MouseEvent): Void
                    {
                        st.play ()
                    }
                }

                st = ScrollableText
                {
                    content: "TranslateTransition Demo"

                    font: Font
                    {
                        name: "Times New Roman BOLD"
                        size: 22
                    }
                    fill: Color.MEDIUMBLUE

                    effect: DropShadow
                    {
                        offsetX: 2
                        offsetY: 2
                        radius: 1
                        spread: 0.25
                        color: Color.GRAY
                    }

                    x: bind r.translateX+r.layoutBounds.width
                    y: bind scene.height/2

                    toX: bind -st.layoutBounds.width
                    toY: bind scene.height/2

                    duration: 5s

                    resize: bind scene.width+scene.height
                }

                Rectangle
                {
                    x: 0
                    y: 0
                    width: 200
                    height: 80
                    arcWidth: 10
                    arcHeight: 10

                    translateX: bind (scene.width-r.layoutBounds.width)/2
                    translateY: bind (scene.height-r.layoutBounds.height)/2

                    fill: null
                    stroke: Color.BLACK
                    strokeWidth: 5
                }
            ]

            clip: Rectangle
                  {
                      x: 0
                      y: 0
                      width: 200
                      height: 80
                      arcWidth: 10
                      arcHeight: 10
                    
                      translateX: bind (scene.width-r.layoutBounds.width)/2
                      translateY: bind (scene.height-r.layoutBounds.height)/2

                      fill: Color.LIGHTYELLOW
                      stroke: Color.BLACK
                      strokeWidth: 5
                  }
        }
    }
}

class ScrollableText extends Text
{
    public var toX: Number;
    public var toY: Number;

    public var duration: Duration;

    public var resize: Number on replace
    {
        if (tt.running)
            tt.playFromStart ()
    }

    public function play (): Void
    {
        tt.playFromStart ()
    }

    def tt = TranslateTransition
    {
        node: this
        fromX: 0
        fromY: 0
        toX: bind toX-x
        toY: bind toY-y
        duration: bind duration
        interpolator: Interpolator.LINEAR
    }
}
